//
//  ISHomeViewController.m
//  ISIDReader
//
//  Created by Simon Liu on 17/3/9.
//  Copyright © 2017年 xzliu. All rights reserved.
//

#import "ISHomeViewController.h"
#import <ISVehicleLicensePreviewSDK/ISVehicleLicensePreviewSDK.h>
#import <ISOpenSDKFoundation/ISOpenSDKFoundation.h>
#import "ISViewController.h"
#import "ISDetailViewController.h"
#import "IntSigSDKStatus.h"

@implementation ISVehicleCardResultItem

-(id) init
{
    self = [super init];
    if (self) {
        _typeText = nil;
        _resultText = nil;
        _numberOfline = 1;
    }
    return self;
}

@end


@interface ISHomeViewController ()<ISOpenSDKCameraViewControllerDelegate>
{
    int _selectRecognType;
    int _recognInt;


}
@property (nonatomic, strong) ISOpenSDKCameraViewController *openSDKCameraVC;

@end

@implementation ISHomeViewController

- (void)viewWillAppear:(BOOL)animated
{
    self.navigationController.navigationBarHidden = YES;

}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    
    self.learnMoreBtn.layer.borderWidth = 1.0f;
    self.learnMoreBtn.layer.borderColor = [UIColor colorWithRed:42.0f/255.0f green:125.0f/255.0f blue:243.0f/255.0f alpha:1].CGColor;
    
    self.cameraBtn.layer.cornerRadius = 30.0f;
    self.ablumBtn.layer.cornerRadius = 30.0f;
    self.recognitionBtn.layer.cornerRadius = 10.0f;

    
    self.learnMoreBtn.tag = 1001;
    self.cameraBtn.tag = 1002;
    self.ablumBtn.tag = 1003;
    self.recognitionBtn.tag = 1003;
    
    self.universalBtn.tag = 1004;
    self.singleBtn.tag = 1005;
    self.noFramewBtn.tag = 1006;
    
    self.navigationController.navigationBarHidden = YES;


    
    [self.learnMoreBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];
    [self.cameraBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];
    [self.ablumBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];
    [self.recognitionBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];

    [self.universalBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];
    [self.singleBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];
    [self.noFramewBtn addTarget:self action:@selector(clickButtonMethod:) forControlEvents:UIControlEventTouchUpInside];


}
 
- (void)clickButtonMethod:(UIButton *)sendBtn
{
    
    //c622b06fe06c53f27b6129cdf1-vagfvt
    NSString *appkey = @"f66f8e499739adb69caf2c2c20-vagfvt";
    NSString *subKey = nil;//reserved for future use

    switch (sendBtn.tag) {
        case 1001:
        {
            ISDetailViewController *detailVC = [[ISDetailViewController alloc] init];
            [self presentViewController:detailVC animated:YES completion:nil];
        }
            break;
            
        case 1003:
        {
            _openSDKCameraVC = [[ISVehicleLicensePreviewController sharedISOpenSDKController] cameraViewControllerWithAppkey:appkey subAppkey:subKey];
            _openSDKCameraVC.shouldHightlightCorners = YES;
            _openSDKCameraVC.customInfo = NSLocalizedString(@"请将行驶证放在框内识别", @"请将行驶证放在框内识别");
            _openSDKCameraVC.delegate = self;
            [self.navigationController pushViewController:_openSDKCameraVC animated:NO];
        }
            break;
        
    }

}

- (void)constructResourcesDidFinishedWithStatusCode:(ISOpenSDKStatus)status
{
    if (status != ISOpenSDKStatusSuccess)
    {
        NSLog(@"Init SDK failed with code:%ld", (long)status);
        NSString *msgStr = [IntSigSDKStatus statusAnalysis:status];
        NSString *messageString = [NSString stringWithFormat:@"[%ld]%@",(long)status,msgStr];
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Error" message:messageString delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [alertView show];
    }}

- (void)cameraViewController:(UIViewController *)viewController didFinishRecognizeCard:(NSDictionary *)resultInfo cardSDKType:(ISOpenPreviewSDKType)sdkType
{
    if (resultInfo != nil)
    {
        [self showISOCRWithAttributes:resultInfo];
        ISViewController *resultVC = [[ISViewController alloc] initWithDictionary:resultInfo loadImageBool:YES];
        UINavigationController *navGCR = [[UINavigationController alloc] initWithRootViewController:resultVC];
        navGCR.modalTransitionStyle = UIModalTransitionStyleCoverVertical;
        [self presentViewController:navGCR animated:NO completion:nil];
        
    }
}
- (NSString *) showISOCRWithAttributes:(NSDictionary *) attributes
{
    NSMutableDictionary *mutableAttributes = [NSMutableDictionary dictionaryWithDictionary:attributes];
    NSMutableString *contentString = [NSMutableString stringWithCapacity:0];
    NSMutableString *string = [mutableAttributes objectForKey:kOpenSDKCardResultTypeCardName];
    if (string.length > 0)
    {
        [contentString appendFormat:@"%@\n", string];
        [mutableAttributes removeObjectForKey:kOpenSDKCardResultTypeCardName];
    }
    NSDictionary *itemInfo = [mutableAttributes objectForKey:kOpenSDKCardResultTypeCardItemInfo];
    {
        ISCardReaderResultItem *plateNumber = [itemInfo valueForKey:kVehicleCardItemPlateNumber];
        if (plateNumber) {
            ISVehicleCardResultItem *item = [[ISVehicleCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Plate Number:", @"号牌号码:");
            item.resultText = plateNumber.itemValue;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];

        }
    }
    
    {
        ISCardReaderResultItem *vehicleType = [itemInfo valueForKey:kVehicleCardItemVehicleType];
        if (vehicleType) {
            ISVehicleCardResultItem *item = [[ISVehicleCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Vehicle Type:", @"车辆类型:");
            item.resultText = vehicleType.itemValue;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];

        }
    }
    
    {
        ISCardReaderResultItem *Owner = [itemInfo valueForKey:kVehicleCardItemOwner];
        if (Owner) {
            ISVehicleCardResultItem *item = [[ISVehicleCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Owner:", @"所有人:");
            item.resultText = Owner.itemValue;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];

        }
    }
    
    {
        ISCardReaderResultItem *address = [itemInfo valueForKey:kVehicleCardItemAddress];
        if (address) {
            ISVehicleCardResultItem *item = [[ISVehicleCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Address:", @"地址:");
            item.resultText = address.itemValue;
            item.numberOfline = 2;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];

        }
    }
    
    {
        ISCardReaderResultItem *useProperty = [itemInfo valueForKey:kVehicleCardItemUseProperty];
        if (useProperty) {
            ISVehicleCardResultItem *item = [[ISVehicleCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Use Property:", @"使用性质:");
            item.resultText = useProperty.itemValue;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];

        }
    }
    
    {
        ISCardReaderResultItem *brandModel = [itemInfo valueForKey:kVehicleCardItemBrandModel];
        if (brandModel) {
            ISVehicleCardResultItem *item = [[ISVehicleCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Brand Model:", @"品牌型号:");
            item.resultText = brandModel.itemValue;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];

        }
    }
    
    {
        ISCardReaderResultItem *itemVIN = [itemInfo valueForKey:kVehicleCardItemVIN];
        if (itemVIN) {
            ISVehicleCardResultItem *item = [[ISVehicleCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Item VIN:", @"车辆识别代号:");
            item.resultText = itemVIN.itemValue;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];

        }
    }
    
    {
        ISCardReaderResultItem *engineNumber = [itemInfo valueForKey:kVehicleCardItemEngineNumber];
        if (engineNumber) {
            ISVehicleCardResultItem *item = [[ISVehicleCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Engine Number:", @"发动机号码:");
            item.resultText = engineNumber.itemValue;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];

        }
    }
    
    {
        ISCardReaderResultItem *registerDate = [itemInfo valueForKey:kVehicleCardItemRegisterDate];
        if (registerDate) {
            ISVehicleCardResultItem *item = [[ISVehicleCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Register Date:", @"注册日期:");
            item.resultText = registerDate.itemValue;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];

        }
    }
    
    {
        ISCardReaderResultItem *issueDate = [itemInfo valueForKey:kVehicleCardItemIssueDate];
        if (issueDate) {
            ISVehicleCardResultItem *item = [[ISVehicleCardResultItem alloc] init];
            item.typeText = NSLocalizedString(@"Issue Date:", @"发证日期:");
            item.resultText = issueDate.itemValue;
            [contentString appendFormat:@"%@: %@\n", item.typeText, item.resultText];

        }
    }
    
    NSLog(@"OCR Result=\n%@",contentString);
    return contentString;
    
}
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
